#-------------------------------------#
#        BigO's Terminator  v1.0      #
#-------------------------------------#


local TArtilleryAntiMatterProjectile = import('/lua/modules/terranprojectiles.lua').TArtilleryAntiMatterSmallProjectile

HellFireShell = Class(TArtilleryAntiMatterProjectile) {

    
    
    OnImpact = function(self, targetType, targetEntity)
       TArtilleryAntiMatterProjectile.OnImpact(self, targetType, targetEntity)   

	   
	   
	   
  ##------------------------##
  ##        3 STEPS         ##
  ##------------------------##
  
          
          ##------------------------------##
	  ##   Step 1: Create Projectile  ##
          ##------------------------------##
       
 	 
 	 
 	 local proj = self:CreateProjectile('/effects/entities/SCUDeath01/SCUDeath01_proj.bp', 0, 0, 0, nil, nil, nil):SetCollision(false)

 	 local proj2 =  self:CreateProjectile('/effects/entities/UEFNukeEffect03/UEFNukeEffect03_proj.bp', 0, 0, 0, nil, nil, nil):SetCollision(false)

	  ##-----------------------------------##
	  ##   Step 2: Get position of Impact  ##
          ##-----------------------------------##          
          
	   local pos = self:GetPosition()  


          ##------------------------------------------------##
	  ##   Step 3: Spawn Projectile at Point of Impact  ##
          ##------------------------------------------------##
          
	   Warp(proj, pos)

	   
	   CreateEmitterAtEntity(self, self:GetArmy(), '/effects/emitters/teleport_01_emit.bp'):ScaleEmitter(1.5)
	   CreateEmitterAtEntity(self, self:GetArmy(), '/effects/emitters/teleport_ring_01_emit.bp'):ScaleEmitter(1.5) 
	   CreateEmitterAtEntity(self, self:GetArmy(), '/effects/emitters/teleport_ring_02_emit.bp'):ScaleEmitter(1.5) 
	   

	   Warp(proj2, pos)
	   
	   

          
	   self:ForkThread(self:CreateInitialFireballSmokeRing(self))
	   
	 
   
    
      end,
      
      
   -----------------------------------------
        CreateInitialFireballSmokeRing = function(self)
              local sides = 12
              local angle = (2*math.pi) / sides
              local velocity = 5
              local OffsetMod = 8       
      
              for i = 0, (sides-1) do
                  local X = math.sin(i*angle)
                  local Z = math.cos(i*angle)
                  self:CreateProjectile('/effects/entities/UEFNukeShockwave01/UEFNukeShockwave01_proj.bp', X * OffsetMod , 1.5, Z * OffsetMod, X, 0, Z)
                      :SetVelocity(velocity):SetAcceleration(-0.5)
              end   
       end,  
    --------------------------------------   

      
}
TypeClass = HellFireShell


