#-------------------------------------#
#        BigO's Terminator  v1.0      #
#-------------------------------------#


local TArtilleryAntiMatterProjectile = import('/lua/modules/terranprojectiles.lua').TArtilleryAntiMatterSmallProjectile

SingleNukeShell = Class(TArtilleryAntiMatterProjectile) {

    
    
    OnImpact = function(self, targetType, targetEntity)
       TArtilleryAntiMatterProjectile.OnImpact(self, targetType, targetEntity)
       
       
        
  ##------------------------##
  ##   Specify Nuke Traits  ##
  ##------------------------##
          
          local Data = {
	 
	 
	 		    NukeInnerRingDamage = 70000,
	 		    NukeInnerRingRadius = 30,
	 		    NukeInnerRingTicks = 24,
	 		    NukeInnerRingTotalTime = 24,
	 		    
	 		    NukeOuterRingDamage = 500,
	 		    NukeOuterRingRadius = 40,
	 		    NukeOuterRingTicks = 20,
	 		    NukeOuterRingTotalTime = 7,	 
	 
	    }     
       
	   
	   
	   
  ##------------------------##
  ##        4 STEPS         ##
  ##------------------------##
  
          
          ##------------------------------##
	  ##   Step 1: Create Projectile  ##
          ##------------------------------##
          
	   local proj =  self:CreateProjectile('/effects/Entities/UEFNukeEffectController01/UEFNukeEffectController01_proj.bp', 0, 0, 0, nil, nil, nil):SetCollision(false)
	   
	  ##-----------------------------------------##
	  ##   Step 2: Give Nuke Data to Projectile  ##
          ##-----------------------------------------##
          
	   proj:PassData(Data)
	   
	   
	  ##-----------------------------------##
	  ##   Step 3: Get position of Impact  ##
          ##-----------------------------------##          
          
	   local pos = self:GetPosition()  


          ##------------------------------------------------##
	  ##   Step 4: Spawn Projectile at Point of Impact  ##
          ##------------------------------------------------##
          
	   Warp(proj, pos)     
   
    
      end,
}
TypeClass = SingleNukeShell


